''
''2016
''Jaime Montenegro
''
''

                                
CON

  _clkmode = xtal1 + pll16x
  _xinfreq = 5_000_000
  i2cclkpin = 6
  i2cdatpin = 7
  baudrate  = 57_600
  initaddr  = 21846
  devaddr   = %1010000
VAR
  long stack[200]

OBJ
   
  pst           : "Parallax Serial Terminal"
  rtc           : "DSRTC_driver"
  i2c           : "Basic_I2C_Driver"
PUB Main  | index, cogmeter[2]
                      
    pst.Start(baudrate)
    rtc.rtcEngineStart(i2cdatpin, i2cclkpin, -1)
    pst.Clear
    i2c.Initialize(i2cclkpin)

    
    repeat index from 0 to 1                ''index will be used to enter meter initial values
    
       pst.Str(String("Enter meter "))        ''and also for pin assignment in the board
       pst.Dec(index + 1)                      ''(passing index as parameter in pulsedet function) 
       pst.Str(String(" initial reading: "))
       cogmeter[index] := pst.DecIn
       pst.NewLine
       cognew (pulsedet(index, cogmeter[index]), @stack[index * 100])
    

PUB pulsedet (optin,pulcnt)  | time 

    
    dira[optin]~
        
    repeat
       
       if ina[optin] == 1
          
          time := deltat(optin)
             if time > 2_000_000
                rtc.readClock
                pulcnt ++
                pst.Str(String("Current meter reading: "))
                pst.Dec(pulcnt)
                pst.Str(String("  "))
                DispTime(optin, pulcnt)
                pst.Str(String(" from pin: "))
                pst.Dec(optin)
                pst.Str(String(" meter ID: "))
                pst.Dec(optin + 1)
                pst.Newline
       waitcnt(clkfreq / 20 + cnt)
    
PUB DispTime (index, pulcnt) | pdata[9] , rdata[9] 

    
  pdata[0] := pulcnt
  
  pdata[1] := rtc.clockMonth
  pst.Dec(pdata[1])
  pst.Str(String("/"))
  
  pdata[2] := rtc.clockDate
  pst.Dec(pdata[2])
  pst.Str(String("/"))

  pdata[3] := rtc.clockYear
  pst.Dec(pdata[3])
  pst.Str(String(" "))

  pdata[4] := rtc.clockDOW
  pst.Str(pdata[4])
  pst.Str(String(" "))
  
  pdata[5] := rtc.clockHour
  pst.Dec(pdata[5])
  pst.Str(String(":"))

  pdata[6] := rtc.clockMinute
  pst.Dec(pdata[6])
  pst.Str(String(":"))
  
  pdata[7] := rtc.clockSecond
  pst.Dec(pdata[7])
  pst.Str(String(" "))

  pdata[8] := rtc.clockAMPM
  if(pdata[8] == 1)
    pst.Str(string("PM"))            
  else
    pst.Str(string("AM"))

  pst.Newline

''''' Writing to EEPROM
 
  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) , pdata[0])
  i2c.Stop(i2cclkpin)

{{ Commenting this section until getting pdata[0] to work  
  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 4, pdata[1])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 8, pdata[2])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 12, pdata[3])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 16, pdata[4])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 20, pdata[5])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 24, pdata[6])
  i2c.Stop(i2cclkpin)

  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 28, pdata[7])
  i2c.Stop(i2cclkpin)
    
  i2c.Start(i2cclkpin)
  i2c.WriteLong(i2cclkpin, devaddr, (index * initaddr) + 32, pdata[8])
  i2c.Stop(i2cclkpin) 

}}
''''' The following code is to test if writing to EEPROM was sucessful '

  i2c.Start(i2cclkpin)
  rdata[0] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr))
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[0])
  pst.Str(String("/"))
  
{{ Commenting this section until getting rdata[0] to work 
  i2c.Start(i2cclkpin)
  rdata[1] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 4)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[1])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[2] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 8)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[2])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[3] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 12)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[3])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[4] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 16)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[4])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[5] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 20)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[5])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[6] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 24)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[6])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[7] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 28)
  i2c.Stop(i2cclkpin)
  pst.Dec(rdata[7])
  pst.Str(String("/"))

  i2c.Start(i2cclkpin)
  rdata[8] := i2c.ReadLong(i2cclkpin, devaddr, (index * initaddr) + 32)
  i2c.Stop(i2cclkpin)
  if(rdata[8] == 1)
    pst.Str(string("PM"))            
  else
    pst.Str(string("AM"))
}}
    
PUB deltat(pin) : delta | time1, time2

    ''repeat until ina[pin] == 1
    time1 := cnt
    repeat until ina[pin] == 0
    time2 := cnt
    delta := time2 - time1